

#include "GSAT.hpp"
using namespace std;

int main(int argc,char* argv[])
{
  
  //Parallel part: to do :)
  GSAT* gsat = new GSAT();
  gsat->setParameters(argc,argv);
  gsat->initialize();
  printf("c nbVariables: %d\n",gsat->getNbVariables());
  printf("c nbClauses: %d\n",gsat->getNbClauses());
  double startTime = gsat->realTime();
  
  bool sat = false;
  while(!sat){
    sat=gsat->start();
    printf("c [iteration:%10d][file:%d][heuristic:%d]Satisfied clauses (begin: %d)(end:%d)\n",
	   gsat->getNbIterations(),
	   gsat->getHeuristicFill(),
	   gsat->getHeuristicSolve(),
	   gsat->getNbSatisfiedClausesFill(),
	   gsat->getNbSatisfiedClausesSolve());
  }
  //Sequential part: recuperate the solution and display the walltime
  printf("s %s\n",sat?"SATISFIABLE":"NOT FOUND");
  printf("c real time : %.4f seconds\n", gsat->realTime() - startTime);
  return sat;
}
